#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <sqlx>

#define AMXMODX_VERSION_1_8_3 1 // Jei naudojate emesn nei AMXX 1.8.3 versij, tuomet ukomentuokite i eilut.

#if !defined AMXMODX_VERSION_1_8_3
	#include <colorchat>
#endif

#define PLUGIN_NAME "AMXX Mute System"
#define PLUGIN_VERSION "1.5"
#define PLUGIN_AUTHOR "aurimasko"

#define TASK_MUTE 5555
#define TABLE_MUTES "amx_mutes"
#define MUTE_PREFIX "[MUTE]"

new g_cSQLHostName, g_cSQLUserName, g_cSQLPassword, g_cSQLDataBase, g_cSQLInfoMode;
new Handle: g_hSQLConnection, Handle: g_hSQLConnect;

enum ePlayerData
{
	iMuteTime,
	szMuteReason[30],
	szMuteAdmin[32]
};

new g_iPlayerInfo[33][ePlayerData];
new bitPlayerMuted;

public plugin_natives()
{
	register_native("get_user_mute", "_get_user_mute");
	register_native("set_user_mute", "_set_user_mute");
}

public plugin_init()
{
	register_plugin(PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR);
	
	#if !defined AMXMODX_VERSION_1_8_3
		register_dictionary_colored("mute_system_colorchat.txt");
	#else
		register_dictionary("mute_system.txt");
	#endif
	
	register_clcmd("say", "cmdSay");
	register_clcmd("say_team", "cmdSay");
	register_forward(FM_Voice_SetClientListening, "fwdVoiceListening");
	
	g_cSQLInfoMode		=	register_cvar("amx_mute_sqlmode", "0"); // 0 - i sql.cfg, 1 - i plugino.
	g_cSQLHostName		=	register_cvar("amx_sql_host", "");
	g_cSQLUserName		=	register_cvar("amx_sql_user", "");
	g_cSQLPassword		=	register_cvar("amx_sql_pass", "");
	g_cSQLDataBase		=	register_cvar("amx_sql_db", "");
	
	if(!get_pcvar_num(g_cSQLInfoMode))
	{	
		new szConfigsDir[50];
		get_configsdir(szConfigsDir, charsmax(szConfigsDir));
	
		server_cmd("exec %s/sql.cfg", szConfigsDir);
		server_exec();
	}
	set_task(1.0, "taskCheckMuteTime", TASK_MUTE, _, _, "b");
}

public plugin_cfg()
{
	new szSQLHostName[40], szSQLUserName[40], szSQLPassword[40], szSQLDataBase[40];
	get_pcvar_string(g_cSQLHostName, szSQLHostName, charsmax(szSQLHostName));
	get_pcvar_string(g_cSQLUserName, szSQLUserName, charsmax(szSQLUserName));
	get_pcvar_string(g_cSQLPassword, szSQLPassword, charsmax(szSQLPassword));
	get_pcvar_string(g_cSQLDataBase, szSQLDataBase, charsmax(szSQLDataBase));
	
	g_hSQLConnection = SQL_MakeDbTuple(szSQLHostName, szSQLUserName, szSQLPassword, szSQLDataBase);

	new iErrorCode, szText[512];
	g_hSQLConnect = SQL_Connect(g_hSQLConnection, iErrorCode, szText, charsmax(szText));

	if(g_hSQLConnect == Empty_Handle)
		set_fail_state(szText);
		
	formatex(szText, charsmax(szText), "\
		CREATE TABLE IF NOT EXISTS `%s` (\
		`id` int(9) auto_increment,\
		`username` varchar(60) not null,\
		`userip` varchar(25) not null,\
		`userauthid` varchar(30) not null,\
		`mutetime` int(15) null,\
		`mutereason` varchar(30) null,\
		`adminname` varchar(60) not null,\
		`adminip` varchar(25) not null,\
		`adminauthid` varchar(32) not null,\
		`createdata` int(15) null,\
		PRIMARY KEY(`id`))\
		ENGINE=MyISAM CHARSET=latin1;\
	", TABLE_MUTES);
	
	SQL_ThreadQuery(g_hSQLConnection, "sqlQueryHandle", szText);
}

public plugin_end()
{
	SQL_FreeHandle(g_hSQLConnection);
	remove_task(TASK_MUTE);
}

public fwdVoiceListening(receiver, sender, bool:listen)
{
	if(receiver == sender)
		return FMRES_IGNORED;

	if(GetPlayerBit(bitPlayerMuted, sender))
	{
		engfunc(EngFunc_SetClientListening, receiver, sender, false);
		return FMRES_SUPERCEDE;
	}
	return FMRES_IGNORED;
}
	
public cmdSay(id)
{
	if(GetPlayerBit(bitPlayerMuted, id))
	{
		new szText[7];
		read_args(szText, charsmax(szText));
		remove_quotes(szText);
	
		if(containi(szText, "/mute") != -1)
		{
			client_print_color(id, id, "%L", id, "MUTE_INFO", MUTE_PREFIX, g_iPlayerInfo[id][iMuteTime], g_iPlayerInfo[id][szMuteReason], g_iPlayerInfo[id][szMuteAdmin]);
			return PLUGIN_HANDLED;
		}
		
		if(szText[0] == '/')
			return PLUGIN_HANDLED;
		
		client_print_color(id, id, "%L", id, "CANT_TALK", MUTE_PREFIX, g_iPlayerInfo[id][iMuteTime]);
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

public client_disconnect(id)
{	
	if((GetPlayerBit(bitPlayerMuted, id)))
	{
		new szIP[32], szQuery[90];
		get_user_ip(id, szIP, charsmax(szIP), 1);

		formatex(szQuery, charsmax(szQuery), "UPDATE `%s` SET `mutetime` = '%d' WHERE `userip`='%s'", TABLE_MUTES, g_iPlayerInfo[id][iMuteTime], szIP);
		
		SQL_ThreadQuery(g_hSQLConnection, "sqlQueryHandle", szQuery);
	}
	
	ResetPlayerBit(bitPlayerMuted, id);
	g_iPlayerInfo[id][iMuteTime] = -1;
	
	copy(g_iPlayerInfo[id][szMuteAdmin], charsmax(g_iPlayerInfo[][szMuteAdmin]), "");
	copy(g_iPlayerInfo[id][szMuteReason], charsmax(g_iPlayerInfo[][szMuteReason]), "");
}

public client_connect(id)
{
	ResetPlayerBit(bitPlayerMuted, id);
	g_iPlayerInfo[id][iMuteTime] = -1;
}

public client_putinserver(id)
{		
	new szIP[32], szQuery[80];
	get_user_ip(id, szIP, charsmax(szIP), 1);

	formatex(szQuery, charsmax(szQuery), "SELECT * FROM `%s` WHERE `userip`='%s'", TABLE_MUTES, szIP);
	
	new iData[1]; iData[0] = id;
	SQL_ThreadQuery(g_hSQLConnection, "sqlSelectHandle", szQuery, iData, 1);
}
	 
public taskCheckMuteTime(taskid)
{
	new iPlayers[32], iNum, id;
	get_players(iPlayers, iNum, "ch");
	
	for(new i = 0; i < iNum; i++)
	{
		id = iPlayers[i];
		
		if((GetPlayerBit(bitPlayerMuted, id)))
		{
			g_iPlayerInfo[id][iMuteTime]--;
			
			if(g_iPlayerInfo[id][iMuteTime] <= 0)
			{
				g_iPlayerInfo[id][iMuteTime] = -1;
				ResetPlayerBit(bitPlayerMuted, id);
				
				new szIP[32], szQuery[70];
				get_user_ip(id, szIP, charsmax(szIP), 1);

				formatex(szQuery, charsmax(szQuery), "DELETE FROM `%s` WHERE `userip`='%s'", TABLE_MUTES, szIP);
				SQL_ThreadQuery(g_hSQLConnection, "sqlQueryHandle", szQuery);
				
				client_print_color(id, id, "%L", id, "NOW_CAN_TALK", MUTE_PREFIX);
			}
		}
	}
}

public _get_user_mute(iPlugin, iParams)
{
	new id = get_param(1);
	
	if((!is_user_connected(id)))
		return false;
		
	return _:GetPlayerBit(bitPlayerMuted, id);
}

public _set_user_mute(iPlugin, iParams)
{
	new id = get_param(1);
	
	if(!is_user_connected(id))
		return false;
	
	switch(get_param(2))
	{
		case 0: // unmute
		{
			if(!(GetPlayerBit(bitPlayerMuted, id)))
				return false;
			
			g_iPlayerInfo[id][iMuteTime] = 0;
			return true;
		}
		
		case 1: // mute
		{
			if(GetPlayerBit(bitPlayerMuted, id))
				return false;		
		
			new admin_id = get_param(3);
	
			g_iPlayerInfo[id][iMuteTime] = get_param(3);
			get_string(4, g_iPlayerInfo[id][szMuteReason], charsmax(g_iPlayerInfo[][szMuteReason]));
			
			new szIP[32], szSteamid[32], szName[32];
			get_user_name(id, szName, charsmax(szName));
			get_user_ip(id, szIP, charsmax(szIP), 1);
			get_user_authid(id, szSteamid, charsmax(szSteamid));
			SQL_QuoteString(g_hSQLConnect, szName, charsmax(szName), szName);
			
			new szAdminIP[32], szAdminSteamid[32];
			get_user_name(admin_id, g_iPlayerInfo[id][szMuteAdmin], charsmax(g_iPlayerInfo[][szMuteAdmin]));
			get_user_ip(admin_id, szAdminIP, charsmax(szAdminIP), 1);
			get_user_authid(admin_id, szAdminSteamid, charsmax(szAdminSteamid));
			SQL_QuoteString(g_hSQLConnect, g_iPlayerInfo[id][szMuteAdmin], charsmax(g_iPlayerInfo[][szMuteAdmin]), g_iPlayerInfo[id][szMuteAdmin]);
			
			new szQuery[356];
			formatex(szQuery, charsmax(szQuery), "INSERT INTO `%s` (`username`, `userip`, `userauthid`, `mutetime`, `mutereason`, `adminname`, `adminip`, `adminauthid`, `createdata`) VALUES ('%s', '%s', '%s', '%d', '%s', '%s', '%s', '%s', '%d')", TABLE_MUTES, szName, szIP, szSteamid, g_iPlayerInfo[id][iMuteTime], g_iPlayerInfo[id][szMuteReason], g_iPlayerInfo[id][szMuteAdmin], szAdminIP, szAdminSteamid, get_systime());
				
			SQL_ThreadQuery(g_hSQLConnection, "sqlQueryHandle", szQuery);
			SetPlayerBit(bitPlayerMuted, id);
		}
	}
	return true;
}

public sqlSelectHandle(iFailState, Handle: hQuery, szError[], iErrcode, iData[], iDataSize, Float:fQueueTime)
{
	if(iFailState == TQUERY_CONNECT_FAILED)
		return set_fail_state("Could not connect to SQL database.");

	else if(iFailState == TQUERY_QUERY_FAILED)
		return set_fail_state("Query failed.");
		
	if(iErrcode)
		return log_amx("[%s] Error in query (%s)!", PLUGIN_NAME, szError);
		
	new id = iData[0], iNumRows = SQL_NumRows(hQuery);
	
	if((!id) || (iNumRows < 1))
		return PLUGIN_CONTINUE;

	if(iNumRows > 1)
	{
		new szIP[32];
		get_user_ip(id, szIP, charsmax(szIP), 1);
		
		log_amx("[%s] There are more than one muted player in this IP (%s)!", PLUGIN_NAME, szIP);
	}
	
	new iTime = SQL_FieldNameToNum(hQuery, "mutetime");
	new iReason = SQL_FieldNameToNum(hQuery, "mutereason");
	new iAdmin = SQL_FieldNameToNum(hQuery, "adminname");

	while(SQL_MoreResults(hQuery))
	{
		g_iPlayerInfo[id][iMuteTime] = SQL_ReadResult(hQuery, iTime);
		SQL_ReadResult(hQuery, iReason, g_iPlayerInfo[id][szMuteReason], charsmax(g_iPlayerInfo[][szMuteReason]));
		SQL_ReadResult(hQuery, iAdmin, g_iPlayerInfo[id][szMuteAdmin], charsmax(g_iPlayerInfo[][szMuteAdmin]));
		SQL_NextRow(hQuery);
	} 
	
	if(g_iPlayerInfo[id][iMuteTime] > 0)
		SetPlayerBit(bitPlayerMuted, id);
		
	return PLUGIN_CONTINUE;
}

public sqlQueryHandle(iFailState, Handle: hQuery, szError[], iErrcode, iData[], iDataSize, Float:fQueueTime)
{
	if(iFailState == TQUERY_CONNECT_FAILED)
		return set_fail_state("Could not connect to SQL database.");

	else if(iFailState == TQUERY_QUERY_FAILED)
		return set_fail_state("Query failed.");
		
	if(iErrcode)
		return log_amx("[%s] Error in query (%s)!", PLUGIN_NAME, szError);
		
	return PLUGIN_CONTINUE;
}
